package java_lec06.samples;

import java.applet.Applet;
import java.awt.Graphics;

@SuppressWarnings("serial")
public class Ans_MovingBall extends Applet implements Runnable{
	
	private Thread repaintThread;
	private Ans_Ball ball;
	
	@Override
	public void init(){
		repaintThread = new Thread(this);
		ball = new Ans_Ball(getWidth() / 2, getHeight() / 2, 5, 0.8, 0.4);
		repaintThread.start();
	}
	@Override
	public void paint(Graphics g){
		ball.draw(g);
//		ball.move();//ここに記述しやすいが間違え
	}
	@Override
	public void run(){
		while(true){
			try{
				if(ball != null)
					ball.move();
				Thread.sleep(10);
				repaint();
			}
			catch(InterruptedException e){
				
			}
		}
	}
	
	/**
	 * ボールを表すクラス<br/>
	 * インナークラスではなく，クラスを分けて作成しても良い．
	 * @author Masaru TAKENAKA
	 *
	 */
	private class Ans_Ball {
		private double x, y;//ボールの中心座標
		private int r;//ボールの半径
		private double dx, dy;//ボールの進む方向
		
		/**
		 * 座標，半径，速度を設定するコンストラクター
		 * @param x
		 * @param y
		 * @param radius
		 * @param dx
		 * @param dy
		 */
		public Ans_Ball(double x, double y, int radius, double dx, double dy){
			this.x = x;
			this.y = y;
			this.r = radius;
			this.dx = dx;
			this.dy = dy;
		}
		/**
		 * ボールを描画する
		 * @param g
		 */
		public void draw(Graphics g){
			g.fillOval((int)(x - r), (int)(y - r), r * 2, r * 2);
		}
		/**
		 * ボールを動かす
		 */
		public void move(){
			x += dx;
			y += dy;
			
			if(getWidth() <= x + r)
				dx = -dx;
			else if(x - r <= 0)
				dx = -dx;
			
			if(getHeight() <= y + r)
				dy = -dy;
			else if(y - r <= 0)
				dy = -dy;
		}
	}

}