package java_lec06.samples;

import java.applet.Applet;
import java.awt.Graphics;

@SuppressWarnings("serial")
public class Sample_Applet extends Applet{

	/**
	 * 1秒間ごとに再描画するためのスレッド
	 */
	private Thread repaintThread;
	
	/**
	 * 実行から経過秒数を格納する変数
	 */
	private int count = 0;
	
	@Override
	public void init() {
		System.out.println("Sample_Applet.init()");
		
		//無名サブクラス
		repaintThread = new Thread(){
			@Override
			public void run(){//並列処理を行うメソッド
				while(true){
					try{
						//1秒間ストップする
						Thread.sleep(1000);
						count++;
					}
					catch(InterruptedException e){
						
					}
					//再描画する
					repaint();
				}
			}
		};
		
		//アプレットの初期サイズを指定
		setSize(500, 250);
		
		//スレッドを開始する
		repaintThread.start();
	}
	
	@Override
	public void start() {
		System.out.println("Sample_Applet.start()");
	}
	
	@Override
	public void repaint(){
		System.out.println("Sample_Applet.repaint()");
		
		//Appletクラスのrepaintメソッドを呼び出す
		super.repaint();
	}
	
	@Override
	public void update(Graphics g){
		System.out.println("Sample_Applet.update()");
		
		//Appletクラスのupdateメソッドを呼び出す
		super.update(g);
	}
	
	@Override
	public void paint(Graphics g){
		System.out.println("Sample_Applet.paint()");
		g.drawString(count + "", 100, 100);
	}
	
	@Override
	public void stop() {
		System.out.println("Sample_Applet.stop()");
	}
	
	@Override
	public void destroy() {
		System.out.println("Sample_Applet.destroy()");
		
		//スレッドの破棄
		repaintThread = null;
	}
	
	

}
