package java_lec06.samples;

import java.applet.Applet;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

@SuppressWarnings("serial")
public class Sample_AppletKeyListener extends Applet implements KeyListener{
	
	@Override
	public void init(){
		//アプレットに対して、KeyListenerを登録する
		//このクラスはKeyListenerを実装しているので、このクラス自体を登録する
		addKeyListener(this);
		
		/*
		 * 最初に、ウィンドウにフォーカスをあわせる必要がある
		 */
	}

	@Override
	public void keyPressed(KeyEvent e) {
		//KeyListenerとswitch文は相性が良い
		
		//押されたキーのキーコードを取得
		int key = e.getKeyCode();
		switch(key){
		case KeyEvent.VK_LEFT://左矢印だった場合
			System.out.println("←");
			break;
		case KeyEvent.VK_RIGHT://右矢印だった場合
			System.out.println("→");
			break;
		case KeyEvent.VK_UP://上矢印だった場合
			System.out.println("↑");
			break;
		case KeyEvent.VK_DOWN://下矢印だった場合
			System.out.println("↓");
			break;
		default://それ以外のキー
			String keyName = KeyEvent.getKeyText(key);
			System.out.println("[" + keyName + "] was pressed.");
			break;
		}
	}

	@Override
	public void keyReleased(KeyEvent e) {
		System.out.println("キーが離されました.");
	}

	@Override
	public void keyTyped(KeyEvent e) {
		System.out.println("キーがタイプされました.");
	}

}
