package java_lec06.samples;

import java.applet.Applet;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;

@SuppressWarnings("serial")
public class Sample_AppletMouseListener extends Applet 
										implements MouseListener, MouseMotionListener, MouseWheelListener{
	
	@Override
	public void init(){
		setSize(300, 300);
		
		/*
		 * アプレットにMouseListener, MouseMotionListener, MouseWheelListenerを登録する
		 * このクラスは上記リスナーを実装しているので、このクラス自体を登録する
		 */
		addMouseListener(this);
		addMouseMotionListener(this);
		addMouseWheelListener(this);
	}

	@Override
	public void mouseClicked(MouseEvent e) {
		//クリックされたボタンを取得する
		int mouseButton = e.getButton();
		
		//現在のマウスの座標を取得
		int x = e.getX();
		int y = e.getY();
		if(mouseButton == MouseEvent.BUTTON1)//左クリックされていた場合を表す
			System.out.println("左ボタンがクリックされました.\t(" + x + ", " + y + ")");
		else if(mouseButton == MouseEvent.BUTTON3)//右クリックされていた場合を表す
			System.out.println("右ボタンがクリックされました.\t(" + x + ", " + y + ")");
	}

	@Override
	public void mouseEntered(MouseEvent e) {
		System.out.println("ウィンドウに入りました.");
	}

	@Override
	public void mouseExited(MouseEvent e) {
		System.out.println("ウィンドウから出ました.");
	}

	@Override
	public void mousePressed(MouseEvent e) {
		//クリックされたボタンを取得する
		int mouseButton = e.getButton();
		
		//現在のマウスの座標を取得
		int x = e.getX();
		int y = e.getY();
		if(mouseButton == MouseEvent.BUTTON1)//左クリックされていた場合を表す
			System.out.println("左ボタンが押されています.\t(" + x + ", " + y + ")");
		else if(mouseButton == MouseEvent.BUTTON3)//右クリックされていた場合を表す
			System.out.println("右ボタンが押されています.\t(" + x + ", " + y + ")");
	}

	@Override
	public void mouseReleased(MouseEvent e) {
		System.out.println("ボタンが離されました.");
	}

	@Override
	public void mouseDragged(MouseEvent e) {
		//現在のマウスの座標を取得
		int x = e.getX();
		int y = e.getY();
		System.out.println("マウスがウィンドウ内をドラッグ中.\t(" + x + ", " + y + ")");
	}

	@Override
	public void mouseMoved(MouseEvent e) {
		//現在のマウスの座標を取得
		int x = e.getX();
		int y = e.getY();
		System.out.println("マウスがウィンドウ内を移動中.\t(" + x + ", " + y + ")");
	}

	@Override
	public void mouseWheelMoved(MouseWheelEvent e) {
		int wheelDirection = e.getWheelRotation();
		if(wheelDirection == 1)
			System.out.println("時計回りにホイールが回されました.");
		else if(wheelDirection == -1)
			System.out.println("反時計回りにホイールが回されました.");
	}
}
