package java_lec06.samples;

import java.applet.Applet;
import java.awt.Graphics;

@SuppressWarnings("serial")
public class Sample_Runnable extends Applet implements Runnable{
	
	/**
	 * 再描画するためのスレッドオブジェクト
	 */
	private Thread repaintThread;
	
	/**
	 * 描画する四角形の幅
	 */
	private int width = 10;
	/**
	 * 描画する四角形の高さ
	 */
	private int height = 10;
	
	@Override
	public void init(){
		setSize(300, 300);
		
		/*
		 * このクラスは、Runnableインターフェイスを実装しているので、
		 * このクラス自体をターゲットに指定する
		 */
		repaintThread = new Thread(this);
		
		//スレッド開始(runメソッドが実行される)
		repaintThread.start();
	}
	@Override
	public void paint(Graphics g){
		g.fillRect(0, 0, width, height);
		width += 5;
		height += 5;
	}
	@Override
	public void run() {
		while(true){
			try{
				//1000ミリ秒間(1秒間)スレッドを停止
				Thread.sleep(1000);//InterruptedExceptionをスローする可能性がある．
				repaint();//画面を再描画する．
			}
			catch(InterruptedException e){
				
			}
		}
	}

}
